<template>
  <b-navbar :toggleable="toogleVar[2]" :type="typeVar[0]" :variant="navbarVar[0]" :class="navbarClass[3]">
    <b-navbar-brand href="#">
      <img src="../../assets/img/logo-header.png" width="120" alt="Aerial Group" />
    </b-navbar-brand>

    <b-navbar-toggle target="nav-collapse"></b-navbar-toggle>

    <b-collapse id="nav-collapse" is-nav>
      <b-navbar-nav>
        <b-nav-item href="/"><b-icon icon="house" font-scale=".9"></b-icon> Home</b-nav-item>

        <li class="nav-item" v-for="link in allLinks" :key="link.id">
          <router-link :to="'/' + link.slug" class="nav-link">{{ link.libelle }}</router-link>
        </li>

        <b-nav-item-dropdown id="dropdown-1" text="Catégorie" right>
          <b-dropdown-item>
            <router-link :to="'/notre-catalogue/consoles/microsoft/xbox-series-x/1-tera'">exemple Scat1 A</router-link>
          </b-dropdown-item>
          <b-dropdown-item>
            <router-link :to="'/notre-catalogue/consoles/sony'">exemple Scat1 B</router-link>
          </b-dropdown-item>
          <b-nav-item-dropdown id="dropdown-2" text="Scat1 C" class="mx-2">
            <b-dropdown-item>exemple scat2 A</b-dropdown-item>
            <b-dropdown-item>Scat2 B</b-dropdown-item>
            <b-nav-item-dropdown id="dropdown-3" text="Scat2 C" class="mx-2">
              <b-dropdown-item>Scat3 A</b-dropdown-item>
              <b-dropdown-item>Scat3 B</b-dropdown-item>
            </b-nav-item-dropdown>
          </b-nav-item-dropdown>
        </b-nav-item-dropdown>

        <!-- <b-nav-item-dropdown id="dropdown-cart" :text="cartStore.cart.length + ' Article(s)'" right>
          <b-dropdown-item>First Action 1</b-dropdown-item>
          <b-dropdown-item>First Action 1</b-dropdown-item>
          <b-dropdown-item>First Action 1</b-dropdown-item>
        </b-nav-item-dropdown> -->

        <!-- Mini panier -->
        <mini-cart></mini-cart>

        <b-nav-item-dropdown right>
          <!-- Using 'button-content' slot -->
          <template v-slot:button-content>
            <b-icon icon="person"></b-icon> User
          </template>
          <b-dropdown-item href="#">Profile</b-dropdown-item>
          <b-dropdown-item href="#">Sign Out</b-dropdown-item>
        </b-nav-item-dropdown>
      </b-navbar-nav>

      <!-- Right aligned nav items -->
      <!-- <b-navbar-nav class="ml-auto">
        <b-nav-form>
          <b-form-input size="sm" class="mr-sm-2" placeholder="Search"></b-form-input>
          <b-button size="sm" class="my-2 my-sm-0" type="submit">Search</b-button>
        </b-nav-form>
      </b-navbar-nav> -->
    </b-collapse>
  </b-navbar>
</template>

<script>
import miniCart from "@/components/AppPanier/miniPanier.vue";
import jsonConfigRoutes from "@/config-data/config-routes.json";
export default {
  components: {
    "mini-cart": miniCart
  },
  created() {
    this.fetchDataMenu();
  },
  mounted: function() {
    // console.log("cartStore", this.cartStore);
    this.$root.$on("bv::dropdown::show", bvEvent => {
      if (bvEvent.componentId === "dropdown-2") {
        this.isDropdown2Visible = true;
      }
    });
    this.$root.$on("bv::dropdown::hide", bvEvent => {
      if (bvEvent.componentId === "dropdown-2") {
        this.isDropdown2Visible = false;
      }
      if (this.isDropdown2Visible) {
        bvEvent.preventDefault();
      }
    });
  },
  data() {
    return {
      jsonConfigRoutes,
      allLinks: [],

      // Variables navbar

      // Point de rupture du toogle
      toggleable: "lg",
      toogleVar: ["sm", "md", "lg"],

      // Contraste du texte (light= text foncé, dark= texte clair)
      type: "light",
      typeVar: ["light", "dark"],

      // Couleur de font du navbar
      variant: "light",
      navbarVar: ["white", "light", "dark", "danger", "info", "warning", "success", "primary", "secondary"],

      // class additionelles
      class: "static-top",
      navbarClass: ["static-top", "fixed-top", "fixed-bottom", "sticky-top", "container"]
    };
  },

  methods: {
    fetchDataMenu() {
      // filtre menu sur disposition Haut puis tri sur ordre
      this.allLinks = this.jsonConfigRoutes
        .filter(item => {
          return item.disposition == "Haut";
        })
        .filter(item => {
          return item.libelle !== "";
        })
        .sort(function(a, b) {
          return parseFloat(a.ordre) - parseFloat(b.ordre);
        });
      console.log("allLinks", this.allLinks);
    }

    // deleteToCart(idx) {
    //   this.$store.dispatch("deleteToCart", { index: idx });
    // }
  }

  // multilevel dropdown
  // mounted: function() {
  //   this.$root.$on("bv::dropdown::show", bvEvent => {
  //     if (bvEvent.componentId === "dropdown-2") {
  //       this.isDropdown2Visible = true;
  //     }
  //   });
  //   this.$root.$on("bv::dropdown::hide", bvEvent => {
  //     if (bvEvent.componentId === "dropdown-2") {
  //       this.isDropdown2Visible = false;
  //     }
  //     if (this.isDropdown2Visible) {
  //       bvEvent.preventDefault();
  //     }
  //   });
  // }
};
</script>
